<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\Locator;
use App\Models\User;

class LocatorPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any Locator');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('view Locator');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create Locator');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('update Locator');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('delete Locator');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any Locator');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('restore Locator');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any Locator');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('replicate Locator');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder Locator');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Locator $locator): bool
    {
        return $user->checkPermissionTo('force-delete Locator');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any Locator');
    }
}
